From 9f0bdb94604ca42207ee6c75d435d1d010daa2f1 Mon Sep 17 00:00:00 2001
From: Sascha Wildner <saw@online.de>
Date: Fri, 9 Jan 2015 18:18:21 +0100
Subject: [PATCH 1/3] WIP uaudio

---
 etc/devd/usb.conf              |   26 +-
 sys/bus/u4b/audio/Makefile     |   10 +-
 sys/bus/u4b/audio/uaudio.c     | 4064 ++++++++++++++++++++++++++++++----------
 sys/bus/u4b/audio/uaudio.h     |    2 +-
 sys/bus/u4b/audio/uaudio_pcm.c |   18 +-
 sys/bus/u4b/audio/uaudioreg.h  |  411 +++-
 6 files changed, 3488 insertions(+), 1043 deletions(-)

diff --git a/etc/devd/usb.conf b/etc/devd/usb.conf
index f406768..02c57ee 100644
--- a/etc/devd/usb.conf
+++ b/etc/devd/usb.conf
@@ -294,6 +294,14 @@ nomatch 32 {
 nomatch 32 {
 	match "bus" "uhub[0-9]+";
 	match "mode" "host";
+	match "vendor" "0x0499";
+	match "product" "(0x1000|0x1001|0x1002|0x1003|0x1004|0x1005|0x1006|0x1007|0x1008|0x1009|0x100a|0x100c|0x100d|0x100e|0x100f|0x1010|0x1011|0x1012|0x1013|0x1014|0x1015|0x1016|0x1017|0x1018|0x1019|0x101a|0x101b|0x101c|0x101d|0x101e|0x101f|0x1020|0x1021|0x1022|0x1023|0x1024|0x1025|0x1026|0x1027|0x1028|0x1029|0x102a|0x102b|0x102e|0x1030|0x1031|0x1032|0x1033|0x1034|0x1035|0x1036|0x1037|0x1038|0x1039|0x103a|0x103b|0x103c|0x103d|0x103e|0x103f|0x1040|0x1041|0x1042|0x1043|0x1044|0x1045|0x104e|0x104f|0x1050|0x1051|0x1052|0x1053|0x1054|0x1055|0x1056|0x1057|0x1058|0x1059|0x105a|0x105b|0x105c|0x105d|0x1503|0x2000|0x2001|0x2002|0x2003|0x5000|0x5001|0x5002|0x5003|0x5004|0x5005|0x5006|0x5007|0x5008|0x5009|0x500a|0x500b|0x500c|0x500d|0x500e|0x500f|0x7000|0x7010)";
+	action "kldload -n uaudio";
+};
+
+nomatch 32 {
+	match "bus" "uhub[0-9]+";
+	match "mode" "host";
 	match "vendor" "0x049f";
 	match "product" "(0x0003|0x0032)";
 	action "kldload -n uipaq";
@@ -3404,6 +3412,22 @@ nomatch 32 {
 nomatch 32 {
 	match "bus" "uhub[0-9]+";
 	match "mode" "host";
+	match "intclass" "0x01";
+	match "intsubclass" "0x01";
+	action "kldload -n uaudio";
+};
+
+nomatch 32 {
+	match "bus" "uhub[0-9]+";
+	match "mode" "host";
+	match "intclass" "0x01";
+	match "intsubclass" "0x03";
+	action "kldload -n uaudio";
+};
+
+nomatch 32 {
+	match "bus" "uhub[0-9]+";
+	match "mode" "host";
 	match "intclass" "0x02";
 	match "intsubclass" "0x88";
 	action "kldload -n ufoma";
@@ -3423,5 +3447,5 @@ nomatch 32 {
 	action "kldload -n umass";
 };
 
-# 1538 USB entries processed
+# 1643 USB entries processed
 
diff --git a/sys/bus/u4b/audio/Makefile b/sys/bus/u4b/audio/Makefile
index 8d4ee34..5100e29 100644
--- a/sys/bus/u4b/audio/Makefile
+++ b/sys/bus/u4b/audio/Makefile
@@ -1,6 +1,8 @@
-KMOD=   uaudio
+# $FreeBSD: head/sys/modules/sound/driver/uaudio/Makefile 266006 2014-05-14 07:33:06Z hselasky $
 
-SRCS=   opt_bus.h opt_usb.h opt_snd.h device_if.h bus_if.h usb_if.h usbdevs.h \
-	mixer_if.h feeder_if.h channel_if.h uaudio.c uaudio_pcm.c
+KMOD=	uaudio
+SRCS=	bus_if.h device_if.h mixer_if.h usb_if.h
+SRCS+=	opt_usb.h opt_bus.h opt_snd.h feeder_if.h channel_if.h usbdevs.h
+SRCS+=	uaudio_pcm.c uaudio.c 
 
-.include <bsd.kmod.mk>  
+.include <bsd.kmod.mk>
